package fw.config;

import fw.db.EntityManager;

import fw.mvc.Controller;
import fw.mvc.Router;
import java.io.File;
import java.net.URL;
import java.util.Enumeration;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class ConfigReader {

    public void read(String path) throws Exception {
        //Load Xml File -------------------------------------------------------------------------//
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();
        org.w3c.dom.Document doc = db.parse(path + "/WEB-INF/fw-config.xml");
        //Read Routers Elements------------------------------------------------------------------------//
        Element root = doc.getDocumentElement();
        Element roter = (Element) root.getElementsByTagName("routers").item(0);
        NodeList rote_list = roter.getElementsByTagName("add");
        for (int i = 0; i < rote_list.getLength(); i++) {
            Element router = (Element) rote_list.item(i);
            String url = router.getAttribute("url");
            String value = router.getTextContent();
            Configuration.addRouter(new Router(url, value));
        }
        //Read Config Data -----------------------------------------------------------------------------//
        Element conifg_tag = (Element) root.getElementsByTagName("properties").item(0);
        NodeList configs_list = conifg_tag.getElementsByTagName("add");
        for (int i = 0; i < configs_list.getLength(); i++) {
            Element add_tag = (Element) configs_list.item(i);
            String name = add_tag.getAttribute("name");
            String value = add_tag.getAttribute("value");
            Configuration.setProperty(name, value);
        }
        //Read SQL Connection Data --------------------------------------------------------------------//
        Element con_root = (Element) root.getElementsByTagName("connections").item(0);
        NodeList cons_list = con_root.getElementsByTagName("connection");
        for (int i = 0; i < cons_list.getLength(); i++) {
            Element con_tag = (Element) cons_list.item(i);
            String name = con_tag.getAttribute("name");
            String driver = con_tag.getAttribute("driver");
            String url = con_tag.getAttribute("url");
            String username = con_tag.getAttribute("username");
            String password = con_tag.getAttribute("password");
            Configuration.setEntityManager(name, new EntityManager(url, username, password, driver));
            
        }
        //Add Controllers --------------------------------------------------------------------------//
        String controller_path = Configuration.getProperty("controllers-package");
        Enumeration<URL> urls = Thread.currentThread().getContextClassLoader().getResources(controller_path.replace(".", "/"));
        while (urls.hasMoreElements()) {
            URL url = urls.nextElement();
            File dir = new File(url.getFile());
            for (File f : dir.listFiles()) {
                Controller cnt = (Controller) Class.forName(controller_path + "." + f.getName().substring(0, f.getName().length() - 6)).newInstance();
                Configuration.addController(cnt);
            }
        }
    }
}
