
package fw.config;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import fw.db.EntityManager;
import fw.mvc.Controller;
import fw.mvc.Router;

public class Configuration {
    //Variables -----------------------------------------------------------------------------------------//
    private static List<Router> routers = new ArrayList<>();
    private static HashMap<String, String> props = new HashMap<>();
    private static HashMap<String, EntityManager> ems = new HashMap<>();
    private static List<Controller> controllers = new ArrayList<>();
    //Properies ---------------------------------------------------------------------------------------//
    public static EntityManager getEntityManager(String name) {
        return ems.get(name);
    }
    public static void setEntityManager(String name, EntityManager em) {
        ems.put(name, em);
    }
    public static String getProperty(String name) {
        return props.get(name);
    }
    public static void setProperty(String key, String value) {
        props.put(key, value);
    }
    public static void addRouter(Router router) {
        routers.add(router);
    }
    public static List<Router> getRouters() {
        return routers;
    }
    public static void addController(Controller cnt) {
        controllers.add(cnt);
    }
    public static List<Controller> getControllers() {
        return controllers;
    }
    public static Controller getController(String name)
    {
        for (Controller cnt : controllers) {
            if (cnt.getClass().getSimpleName().equals(name))return cnt;
        }
        return null;
    }
}
