package fw.db.sql;

import fw.db.Entity;
import fw.db.EntityManager;
import fw.db.iQuery;
import fw.time.PersianDate;
import java.lang.reflect.Field;
import java.util.List;
import java.sql.*;
import java.util.ArrayList;

public class Query extends iQuery {
    private String query = null;
    private Object[] params = null;
    private Connection connection = null;
    private PreparedStatement statment = null;
    private ResultSet resultset = null;
    
    public Query(String query, Object[] params, EntityManager em) throws SQLException, ClassNotFoundException {
        this.params = params;
        this.query = query;
        this.entitymanager = em;
        //Bulid Connection And Statment
        Class<?> forName = Class.forName(em.getDriver());
        this.connection = DriverManager.getConnection(entitymanager.getConnectionString(), entitymanager.getUserName(), entitymanager.getPassword());
        this.statment = connection.prepareStatement(this.query);
        for (int i = 0; i < this.params.length; i++) {
            Object value = this.params[i];
            if (value != null) {
                if (value instanceof PersianDate) {
                    PersianDate pd = (PersianDate) value;
                    //  stat.setObject(i+1,pd.Convert(PersianDate.DateTypes.Gregorian).toString()); NEw Version ****
                } else {
                    statment.setObject(i + 1, this.params[i]);
                }

            }
        }
    }

    public <T> T getResultList(Class cls) throws Exception {
        List<T> items = new ArrayList<>();
        resultset = statment.executeQuery();
        while (resultset.next()) {
            Object item = this.convert(cls); //Create The New Instance and Full Properties
            items.add((T) item);
        }
        close();
        return (T) items;
    }

    public <T> T getSingleResult(Class cls) throws Exception {
            resultset = statment.executeQuery();
            resultset.next();
        if (cls == Entity.class) {

            Object item = convert(cls);
            this.close();
            return (T) item;
        } else {
            Object result = null;
            result = resultset.getObject(1);
            this.close();
            return (T) result;
        }
    }

    private Object convert(Class cls) throws Exception {
        Object item = cls.newInstance();
        Field[] fields = cls.getDeclaredFields();
        for (Field field : fields) {
            fw.db.annotation.Field anon = field.getAnnotation(fw.db.annotation.Field.class);
            Object value = resultset.getObject(anon.name());
            field.setAccessible(true);
            Object temp_value = null;
            if (value == null) {
                continue;
            }
            if (!field.getType().isInstance(value)) {
                temp_value = field.getType().getMethod("valueOf", value.getClass()).invoke(null, value.toString()); //@todo -> value of by entity field type
            } else {
                temp_value = value;
            }
            field.set(item, temp_value);
        }
        return item;
    }

    public int executeUpdate() throws Exception {
        int rows = -1;
        rows = statment.executeUpdate();
        this.close();
        return rows;
    }

    public void close() throws SQLException {
        connection.close();
        statment.close();
        resultset.close();
    }

    public void dispose() {
        connection = null;
        resultset = null;
        statment = null;
        entitymanager = null;
        params = null;
        query = null;
        System.gc();
    }
}
