
package fw.mvc;

import fw.config.Configuration;
import fw.mvc.annotation.RequestMapping;
import fw.mvc.servlet.Dispatcher;
import java.io.IOException;
import java.lang.reflect.Method;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
public class ActionInfo {
    
    private String _controller;
    private String _action;
    private String[] _args = null;
    
    public ActionInfo() {
    }
    
    public ActionInfo(String controller, String method, String[] args) {
        this._controller = controller;
        this._action = method;
        this._args = args;
        
    }
    
    public Object invoke() throws ReflectiveOperationException, IOException {
        Object[] args = null;
        if (_args != null && _args.length != 0) {
            args = new Object[_args.length];
        }
        Controller cnt = Configuration.getController(_controller);
        Class cls = cnt.getClass();
        Method actions[] = cls.getDeclaredMethods();
        for (Method action : actions) {
            if (action.getName().equals(_action)) {
                RequestMapping req_map = action.getAnnotation(RequestMapping.class);
                if (req_map != null) {
                    if (req_map.method() != RequestMapping.Method.ALL && !req_map.method().toString().equals(Dispatcher.request.getMethod())) {
                        break;
                    }
                }
                Class[] types = action.getParameterTypes();
                
                cnt.request = Dispatcher.request;
                cnt.response = Dispatcher.response;
                if (_args != null) {
                    if (types.length != _args.length) {
                        continue;
                    }
                    for (int i = 0; i < _args.length; i++) {
                        if (types[i].getSimpleName().equals("String")) {
                            args[i] = _args[i];
                        } else {
                            args[i] = (Object) types[i].getMethod("valueOf", String.class).invoke(null, _args[i]);
                        }
                        
                    }
                }
                Object result = action.invoke(cnt, args);
                return result;
            }
        }
        return null;
    }

    // <editor-fold defaultstate="collapsed" desc="Properties">
    public void setController(String controller) {
        this._controller = controller;
    }
    
    public void setAction(String action) {
        this._action = action;
    }
    
    public String getAction() {
        return _action;
    }
    
    public String getController() {
        return this._controller;
    }
    
    public String[] getArgs() {
        return _args;
    }
    
    public void setArgs(String[] _args) {
        this._args = _args;
    }
    // </editor-fold>
}
