package fw.mvc;
import fw.config.Configuration;
import fw.mvc.servlet.Dispatcher;
import fw.mvc.views.JspView;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.swing.text.View;


public class Controller {

    protected HttpServletResponse response = null;
    protected HttpServletRequest request = null;
    protected PrintWriter out = null;

    protected void render(JspView view) {
        try {

            RequestDispatcher dispatcher = request.getRequestDispatcher(Configuration.getProperty("views-path") + view.getName() + ".jsp");
            if (dispatcher != null) {
                dispatcher.forward(request, response);
            }
        } catch (ServletException | IOException ex) {
          Dispatcher.handelException(ex.getCause());
        }

    }
//
//
//    protected void RenderGroovy(View view) {
//        groovy.text.TemplateEngine s = new GStringTemplateEngine();
//        try {
//
//            groovy.text.Template temp = s.createTemplate(new File(request.getRealPath("") + Configuration.getProperty("views-path") + view.getName() + ".html"));
//            HashMap<String, Object> map = new HashMap<>();
//            for (Object key : view.getData().keySet().toArray()) {
//                map.put(key.toString(), view.getData().get(key.toString()));
//            }
//            Writable make = temp.make(map);
//            response.getWriter().print(make.toString());
//        } catch (CompilationFailedException | ClassNotFoundException | IOException ex) {
//            Dispatcher.handelException(ex, response);
//        }
//    }

    protected void redirect(String url) {
        try {
            response.sendRedirect(url);
        } catch (Exception ex) {
            Dispatcher.handelException(ex);
        }
    }
}
