package fw.mvc;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.regex.Pattern;

public class Router {

    private String url="";
    private String value="";
    private String regex="";
    private HashMap<String, String> vars;
    private String args="";

    public Router(String url, String value) {
        this.value = value;
        this.url = normalize(url);
        vars = new HashMap<>();
        this.regex = new String();
        getRegEx();
        getArgs();
    }

    private void getRegEx() { // Generate Regular For URL
        String[] parts = url.split("\\/");
        for (int i = 0; i < parts.length; i++) {
            if (parts[i].startsWith("{") && parts[i].endsWith("}")) {
                String part = parts[i].replace("{", "").replace("}", "");
                String reg = part.split("\\:")[1];
                String name = part.split("\\:")[0];
                vars.put(String.valueOf(i), name);
                regex += "/" + reg;
            } else {
                regex += "/" + parts[i];
            }
        }
    }

    public void getArgs() {
        int start_index = value.indexOf("(");
        if (start_index > 0) {
            args = value.substring(start_index + 1, value.length() - 1);
            value = value.substring(0, start_index);
        }
    }

    public boolean matches(String _url) {
        return Pattern.compile(regex).matcher(_url).matches();
    }

    public ActionInfo getAction(String url) {
        String args_temp = args;
        ActionInfo info = new ActionInfo();
        url = normalize(url);
        String result = value;
        String[] parts = url.split("\\/");
        for (int i = 0; i < parts.length; i++) {
            if (vars.containsKey(String.valueOf(i))) {
                String key = vars.get(String.valueOf(i));
                String value = parts[i];
                result = result.replace("{" + key + "}", value); // Replacace Value In URL String With Params
                args_temp = args_temp.replace("@" + key, value); // Replacace Value In URL String With Params
            }
        }
        if (!args.isEmpty())
        {
        String[] args_arr = args_temp.split(",");
        info.setArgs(args_arr);
            
        }
        String[] t = result.split("\\.");
        info.setController(t[0]);
        info.setAction(t[1]);
        

        return info;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setUrl(String url) {

        this.url = normalize(url);
    }

    public String getUrl() {
        return url;
    }

    public String getValue() {
        return value;
    }

    private String normalize(String url) {
        if (url.startsWith("/")) {
            url = url.substring(1);
        }
        if (url.endsWith("/")) {
            url = url.substring(0, url.length() - 1);
        }
        return url;
    }
}
