package fw.mvc.servlet;

/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
import fw.config.ConfigReader;
import fw.config.Configuration;
import fw.mvc.Router;
import java.io.*;
import javax.activation.MimetypesFileTypeMap;
import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Dispatcher implements Filter {

    private static final boolean debug = true;
    private FilterConfig filterConfig = null;
    public static HttpServletResponse response = null;
    public static HttpServletRequest request = null;

    public Dispatcher() {
    }

    public static void handelException(Throwable ex) {
        try {
            StackTraceElement stack = ex.getStackTrace()[0];
            String msg = String.format("<h3 style='background-color:red;color:#fff;padding: 5px 10px;border-radius: 5px;'>Exception : %s</h3><p style='background-color:#aaa;padding:10px;border-radius: 5px;'>Message : %s <br/>Class : %s <br/> Method : %s <br/> Line Number : %s </p>", ex.toString(), ex.getMessage(), stack.getClassName(), stack.getMethodName(), stack.getLineNumber());
            response.getWriter().print(msg);
        } catch (Exception ex1) {
            ex1.printStackTrace();
        }
    }

    public void doFilter(ServletRequest baserequest, ServletResponse baseresponse, FilterChain chain) throws IOException, ServletException {
        HttpServletRequest request = (HttpServletRequest) baserequest;
        HttpServletResponse response = (HttpServletResponse) baseresponse;

        try {

            String url = request.getRequestURI();
            Dispatcher.request = request;
            Dispatcher.response = response;

            if (url.startsWith("/public") || url.startsWith("/app")) {
                chain.doFilter(baserequest, baseresponse);
            } else {
                response.setContentType("text/html;charset=UTF-8");
                request.setCharacterEncoding("UTF-8");
                for (Router router : Configuration.getRouters()) {
                    if (router.matches(url)) {
                        Object output = router.getAction(url).invoke();
                        if (output != null) {
                            response.getWriter().print(output);
                        }
                        break;
                    }
                }
            }

        } catch (IOException | ReflectiveOperationException ex) {
            Throwable cause = ex.getCause();
            handelException(cause);
        }
    }

    public void destroy() {
    }

    /**
     * Init method for this filter
     */
    public void init(FilterConfig filterConfig) {
        this.filterConfig = filterConfig;
        try {
            ConfigReader cm = new ConfigReader();
            cm.read(filterConfig.getServletContext().getRealPath("/"));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
