
package fw.mvc.views;

import fw.config.Configuration;
import fw.mvc.IView;
import fw.mvc.servlet.Dispatcher;
import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;

public class JspView implements IView {
private String name;

    public JspView(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }


    @Override
    public String Render() {
        try {
            RequestDispatcher dispatcher = Dispatcher.request.getRequestDispatcher(Configuration.getProperty("views-path") + name + ".jsp");
            if (dispatcher != null) {
                dispatcher.forward(Dispatcher.request, Dispatcher.response);
            }
        } catch (ServletException | IOException ex) {
            Dispatcher.handelException(ex);
        }
        return this.toString();
    }
}
